package uap.mw.trans;

package ..deTemp.1732551575863;

import nc.bs.mw.itf.MwTookit;
import nc.middleware.tran.IContainerTransProxy;
import nc.middleware.tran.IerpTransactionManager;
import nc.middleware.tran.NCDataSource;
import uap.mw.trans.UAPTransactionManagerProxy;
import uap.mw.trans.UAPUserTransanction;
import uap.mw.trans.itf.IUAPTransactionManagerProxy;

public class TransactionFactory {
  private static Class<?> transactionManagerClass = null;
  
  private static Class<?> userTransactionClass = null;
  
  private static Class<?> xADataSourceClass = null;
  
  private static IUAPTransactionManagerProxy defaultProxy = null;
  
  public static IContainerTransProxy getTMProxy() {
    return (IContainerTransProxy)UAPTransactionManagerProxy.getInstance();
  }
  
  public static IerpTransactionManager getTManager() {
    synchronized (uap.mw.trans.TransactionFactory.class) {
      if (transactionManagerClass == null) {
        String TManager_classname = 
          (MwTookit.getRuntimeEnviroment().getMiddleProperty().getMiddleParameter()).TransactionManagerClass;
        try {
          transactionManagerClass = Class.forName(TManager_classname);
        } catch (ClassNotFoundException e) {
          throw new RuntimeException("load transaction manager  class error: " + TManager_classname);
        } 
      } 
    } 
    try {
      return (IerpTransactionManager)transactionManagerClass.newInstance();
    } catch (Exception e) {
      throw new RuntimeException("create transaction manager error", e);
    } 
  }
  
  public static UAPUserTransanction getUTransaction() {
    synchronized (uap.mw.trans.TransactionFactory.class) {
      if (userTransactionClass == null) {
        String UT_classname = "uap.mw.trans.UAPUserTransanction";
        try {
          userTransactionClass = Class.forName(UT_classname);
        } catch (ClassNotFoundException e) {
          throw new RuntimeException("load user transaction manager  class error: " + UT_classname);
        } 
      } 
    } 
    try {
      return (UAPUserTransanction)userTransactionClass.newInstance();
    } catch (Exception e) {
      throw new RuntimeException("create user transaction manager error", e);
    } 
  }
  
  public static NCDataSource getXADataSource() {
    synchronized (uap.mw.trans.TransactionFactory.class) {
      if (xADataSourceClass == null) {
        String xads_classname = "uap.mw.ds.UAPDataSource";
        try {
          xADataSourceClass = Class.forName(xads_classname);
        } catch (ClassNotFoundException e) {
          throw new RuntimeException("load xADate source class error: " + xads_classname);
        } 
      } 
    } 
    try {
      return (NCDataSource)xADataSourceClass.newInstance();
    } catch (Exception e) {
      throw new RuntimeException("create xADate source class error", e);
    } 
  }
}
